unit waitings;

{$mode objfpc}{$H+}
{$goto on}

interface

Procedure Waitms(f_CPU1:longword;Time:word);  // cpu_clock in Hz , max 2.55 sec

implementation

// Waitingtime[ms]
Procedure Waitms(f_CPU1:longword;Time:word);  // max 2.55 sec
label    //Labels, here for the loop, has to be declared explicitly
  outer,inner1,inner2;
var
 faktor:byte;
 time2:byte;
begin
 time2:=time div 10;
 faktor:=15*f_CPU1 div 1000000;
asm               //asm states inline assembly block until the next END statement
  ldd r20,Time2    //Variables can be accessed, here a local variable
  outer:
   ldd r21,faktor   // faktor ldd=Variable laden
    inner1:         //640*Faktor= 640*15*1 = 9600 cycles/1MHz
      ldi r22,128   // ldi=Konstate laden
      inner2:       ////5*128 = 640 cycles
        nop         //1 cycle
        nop         //1 cycle
      dec r22       //1 cycle
      brne inner2     //2 cycles in case of branch //one loop in sum 5 cycles
    dec r21
    brne inner1
  dec r20
  brne outer
end['r20','r21','r22']; //Used registers to be published to compiler
end;


end.

